unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, CoolMenu, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    PMenu: TPopupMenu;
    PMenuItem: TMenuItem;
    CMenu: TCoolMenu;
    CMenuItem: TCoolMenuItem;
    procedure Clicked(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (PMenu <> nil) and (Button = mbRight) then
      TrackPopupMenu(PMenu.Handle, TPM_LEFTALIGN, x+left, y+top, 0, Handle, NIL)
end;

procedure TForm1.Clicked;
begin
  ShowMessage('Clicked');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  PMenu := TPopupMenu.Create(Self);
  PMenuItem := TMenuItem.Create(Self);
  PMenuItem.Caption := '&New Item';
  PMenuItem.OnClick := Clicked; 
  PMenu.Items.Add(PMenuItem);

  CMenu := TCoolMenu.Create(Self);
  CMenuItem := CMenu.NewItem;
  CMenuItem.Menu := PMenu;
  CMenuItem.MenuItem := PMenuItem;
  CMenuItem.Picture.Icon.Assign(Application.Icon);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  PMenu.Free;
  CMenu.Free;
end;

end.
